//
// file : aiState_approach.cpp
//

#include <Windows.h>
#include "aiState.h"
#include "aiContoller.h"

#pragma region state_approach
void cAI_state_approach::enter()
{
	m_bPositionReached = false;
	m_fElapsed = 0;
}

void cAI_state_approach::update(float t)
{
	cNPC_controller *parent = (cNPC_controller*)m_parent;
	
	static int p[4] = { 250, 40, 250, 100};
	static int n = 0; 
	static int fire = 2;

	parent->targetx = p[n];
	parent->targety = p[n + 1];
	if (parent->posx == p[n] && parent->posy == p[n + 1] &&
		parent->posx == parent->targetx && parent->posy == parent->targety)
	{
		parent->fireThisFrame = fire;
		fire--; if (fire < 0) fire = 0; // shoots twice

		n += 2; if (n == 4) { n = 0; }      // cycle 0, 1, 0, 1, 0, 1, 0 ...	
		parent->targetTime = 1.f;
		if (parent->posx == 250 && parent->posy == 100)
		{
			m_bPositionReached = true;
		}
	}
}


eAI_state cAI_state_approach::checkTransition(float t)
{
	//cNPC_controller *parent = (cNPC_controller*)m_parent;
	if (m_bPositionReached)
	{
		m_bPositionReached = false;
		return FSM_STATE_IDLE; // todo : go to idle and set second iteration to search...work on search next
	}
	
	return FSM_STATE_APPROACH;
}

void cAI_state_approach::exit() {}

#pragma endregion

// ****************************
//void cAI_state_approach_character::enter() {} whoops....
void cAI_state_approach_character::update(float t) {}
eAI_state cAI_state_approach_character::checkTransition(float t) { return FSM_STATE_APPROACH_CHARACTER; }
void cAI_state_approach_character::exit() {}


void cAI_state_approach_bumper::update(float t) {}
eAI_state cAI_state_approach_bumper::checkTransition(float t) { return FSM_STATE_APPROACH_BUMPER; }
void cAI_state_approach_bumper::exit() {}


void cAI_state_approach_pipe_breakage::update(float t) {}
eAI_state cAI_state_approach_pipe_breakage::checkTransition(float t) { return FSM_STATE_APPROACH_PIPE; }
void cAI_state_approach_pipe_breakage::exit() {}


void cAI_state_drive_pin::update(float t) {}
eAI_state cAI_state_drive_pin::checkTransition(float t) { return FSM_STATE_DRIVE_PIN; }
void cAI_state_drive_pin::exit() {}

