//
// file : aiState_idle.cpp
//

#include <Windows.h>
#include "aiState.h"
#include "aiContoller.h"

#pragma region state_idle
void cAI_state_idle::update(float t) {}
eAI_state cAI_state_idle::checkTransition(float t)
{
	cNPC_controller *parent = (cNPC_controller*)m_parent;
	
	static float duration = 0.f;
	duration += t;
	if (duration > 3.f)
	{
		duration = 0.f;
		static int temp = 0;
		switch (temp)
		{
		case 0:
			temp = 1;
			return FSM_STATE_APPROACH;
		case 1:
			return FSM_STATE_SEARCH;
		}
	}
	return FSM_STATE_IDLE;
}
void cAI_state_idle::exit() {}
#pragma endregion

void cAI_state_reset_run::update(float t) {}
eAI_state cAI_state_reset_run::checkTransition(float t) { return FSM_STATE_RESET; }
void cAI_state_reset_run::exit() {}


void cAI_state_search_pipe::update(float t) 
{
	cNPC_controller *parent = (cNPC_controller*)m_parent;
	parent->targetx = keys[keyCursor].px;
	parent->targety = keys[keyCursor].py;
	if (parent->posx == keys[keyCursor].px && parent->posy == keys[keyCursor].py &&
		parent->posx == parent->targetx && parent->posy == parent->targety)
	{
		parent->fireThisFrame = keys[keyCursor].aux;
		keyCursor++; if (keyCursor == numKeys)keyCursor = 0; // reset
		parent->targetTime = keys[keyCursor].t;

	}
}

eAI_state cAI_state_search_pipe::checkTransition(float t)
{
	cNPC_controller *parent = (cNPC_controller*)m_parent;
	if (parent->bFoundPipe == true)
		return FSM_STATE_ATTACK_PATTERN_ALPHA; //then drive pin after
	
	return FSM_STATE_SEARCH; 
}
void cAI_state_search_pipe::exit() {}



