//
// file : machine.h
//

#ifndef _AI_MACHINE_H_
#define _AI_MACHINE_H_

#include <vector>
#include "state_base.h"

class cAI_machine : public cAI_state
{
public:
	cAI_machine(int type = FSM_MACH_NONE, cAI_controller *parent = NULL)
	{
		m_type = type;
		m_parent = parent;
		m_currentState = NULL;
		m_defaultState = NULL;
		m_goalState = NULL;
	}

	virtual void update(float t);
	virtual void addState(cAI_state *state)        { m_stateList.push_back(state); }
	virtual void setDefaultState(cAI_state *state) { m_defaultState = state; }
	virtual void setGoalId(eAI_state goal)         { m_goalId = goal; }
	virtual bool doTransitionState(eAI_state goal);
	virtual void reset();

	int m_type;
	cAI_state* getCurrentState() { return m_currentState; }

private:
	std::vector<cAI_state*> m_stateList;
	cAI_state *m_currentState;
	cAI_state *m_defaultState;
	cAI_state *m_goalState;

	eAI_state m_goalId;
};

#endif//_AI_MACHINE_H_
