//
// file : state_base.h
//

#ifndef _STATE_BASE_H_
#define _STATE_BASE_H_

#include "state_enum.h"
#include "controller.h"

class cAI_state
{
public:
	cAI_state(eAI_state type = FSM_STATE_NONE, cAI_controller *parent = NULL)
	{
		m_type = type;
		m_parent = parent;
	}

	virtual void enter()                  {}
	virtual void exit()                   {}
	virtual void update(float t)          {}
	virtual void initialize()             {}
	virtual eAI_state checkTransition(float t) { return FSM_STATE_NONE; }

	cAI_controller *m_parent;
	eAI_state       m_type;
};

#endif//_STATE_BASE_H_
