#pragma once

class HoseBit
{
public:
	HoseBit()
	{
		sprite.LoadFromFile("Assets/bit.png");
		transform.Reset();
		transform.Translate(pos.x - (0.3*sprite.width), pos.y-sprite.height);
	}

	vec2 pos = { 150.f, 250.f };
	bool isOn = false;
	olc::GFX2D::Transform2D transform;
	olc::Sprite sprite;
	vec2 outOffset = { 20.f, -20.f };

	void update(Terrain* pt)
	{
		int here = int(pos.y * 1600 + pos.x);
		int down = here + 1600;
		int up = here - 1600;
		if (pt->map[here] == 0)
		{
			if (pt->map[down] == 0)
			{
				pos.y++;
				transform.Translate(0.f, 1.f);
			}
		}
		else {
			if (pt->map[up] == 1)
			{
				pos.y--;
				transform.Translate(0.f, -1.f);
			}
		}
	}

	void draw(int camX, int camY, bool flip=false)
	{
		olc::GFX2D::Transform2D t = transform;
		t.Translate(-camX, -camY);
		olc::GFX2D::DrawSprite(&sprite, t, flip);
	}

};