#pragma once

class Pipes
{
public:
	void init() 
	{
		pipe_straight.LoadFromFile("Assets/pipe_straight.png");
		pipe_elbowZ.LoadFromFile("Assets/pipe_elbowZup.png");
		pipe_elbowZd.LoadFromFile("Assets/pipe_elbowZdown.png");
		pipe_elbow.LoadFromFile("Assets/pipe_elbow_down.png");
		pipe_elbow_r.LoadFromFile("Assets/pipe_elbow_right.png");
		pipe_elbow_u.LoadFromFile("Assets/pipe_elbow_up.png");
		pipe_straight_d.LoadFromFile("Assets/pipe_straight_down.png");
		pipe_stub.LoadFromFile("Assets/pipe_stub.png");
	}

	int startY = 283;
	int pipeID = 3;

	void drawCollisionData(Terrain *t)
	{
		int x = 0;
		int y = startY;

		RECT rect;
		int nPipes = pipeConfig[pipeLayoutIndex][0] ;
		for (int i = 1; i <= nPipes; i++)
		{
			switch (pipeConfig[pipeLayoutIndex][i]) // swap this out per level
			{
			case 0: // pipe_straight
				for (int j = 0; j < pipe_straight.height; j++) {
					for (int i = 0; i < pipe_straight.width; i++) {
						if (pipe_straight.GetPixel(i, j).a != 0) {
							t->map[((y + j)*t->nMapWidth) + x + i] = pipeID;
						}
					}
				}
				x += 80;
				break;
			case 1: // pipe_elbowZ
				y -= 2; // draw
				for (int j = 0; j < pipe_elbowZ.height; j++) {
					for (int i = 0; i < pipe_elbowZ.width; i++) {
						if (pipe_elbowZ.GetPixel(i, j).a != 0) {
							t->map[((y + j)*t->nMapWidth) + x + i] = pipeID;
						}
					}
				}
				x += 40; y -= 26;
				break;
			case 2: // pipe_elbow
				y += 25;
				for (int j = 0; j < pipe_elbow.height; j++) {
					for (int i = 0; i < pipe_elbow.width; i++) {
						if (pipe_elbow.GetPixel(i, j).a != 0) {
							t->map[((y + j)*t->nMapWidth) + x + i] = pipeID;
						}
					}
				}
				y += 48;
				break;
			case 3: // pipe_straight vertical
				x += 10;
				for (int j = 0; j < pipe_straight_d.height; j++) {
					for (int i = 0; i < pipe_straight_d.width; i++) {
						if (pipe_straight_d.GetPixel(i, j).a != 0) {
							t->map[((y + j)*t->nMapWidth) + x + i] = pipeID;
						}
					}
				}
				x -= 10;
				y += 80;
				break;
			case 4: // pipe_elbowZd (z down)
				y += 26;
				for (int j = 0; j < pipe_elbowZd.height; j++)
				{
					for (int i = 0; i < pipe_elbowZd.width; i++)
					{
						if (pipe_elbowZd.GetPixel(i, j).a != 0)
						{
							t->map[((y + j)*t->nMapWidth) + x + i] = pipeID;
						}
					}
				}
				x += 40; y += 2;
				break;
			case 5: // pipe_elbow_r
				x += 13;
				for (int j = 0; j < pipe_elbow_r.height; j++) {
					for (int i = 0; i < pipe_elbow_r.width; i++) {
						if (pipe_elbow_r.GetPixel(i, j).a != 0) {
							t->map[((y + j)*t->nMapWidth) + x + i] = pipeID;
						}
					}
				}
				x += 44; 
				y -= 15;
				break;
			case 6: // pipe_elbow_u
				y -= 3;
				for (int j = 0; j < pipe_elbow_u.height; j++) {
					for (int i = 0; i < pipe_elbow_u.width; i++) {
						if (pipe_elbow_u.GetPixel(i, j).a != 0) {
							t->map[((y + j)*t->nMapWidth) + x + i] = pipeID;
						}
					}
				}
				x += 10;
				y -= 55;
				break;
			case 7: // pipe_stub
				y -= 3;
				for (int j = 0; j < pipe_stub.height; j++) {
					for (int i = 0; i < pipe_stub.width; i++) {
						if (pipe_stub.GetPixel(i, j).a != 0) {
							t->map[((y + j)*t->nMapWidth) + x + i] = pipeID;
						}
					}
				}
				y -= 41;
				break;
			case 8: // pipe_straight vertical
				y -= 20;
				for (int j = 0; j < pipe_straight_d.height; j++) {
					for (int i = 0; i < pipe_straight_d.width; i++) {
						if (pipe_straight_d.GetPixel(i, j).a != 0) {
							t->map[((y + j)*t->nMapWidth) + x + i] = pipeID;
						}
					}
				}
				y -= 80;
			}
		}
	}

	void draw(olc::PixelGameEngine* e, int cx, int cy) 
	{
		int x = 0;
		int y = startY;

		int nPipes = pipeConfig[pipeLayoutIndex][0];
		for (int i = 1; i <= nPipes; i++)
		{
			switch (pipeConfig[pipeLayoutIndex][i]) // swap this out per level
			{
			case 0:
				e->DrawSprite(x - cx, y - cy, &pipe_straight);
				x += 80;
				break;
			case 1:
				y -= 2;
				e->DrawSprite(x - cx, y - cy, &pipe_elbowZ);
				x += 40; y -= 26;
				break;
			case 2:
				y += 25;
				e->DrawSprite(x - cx, y - cy, &pipe_elbow); 
				y += 48;
				break;
			case 3:
				x += 10;
				e->DrawSprite(x - cx, y - cy, &pipe_straight_d);
				x -= 10;
				y += 80;
				break;
			case 4:
				y += 26;
				e->DrawSprite(x - cx, y - cy, &pipe_elbowZd);
				x += 40; y += 2;
				break;
			case 5:
				x += 12;
				e->DrawSprite(x-cx, y-cy, &pipe_elbow_r);
				x += 45;
				y -= 15;
				break;
			case 6:
				y-=3;
				e->DrawSprite(x - cx, y - cy, &pipe_elbow_u);
				x += 9;
				y -= 55;
				break;
			case 7:
				y -= 3;
				e->DrawSprite(x - cx, y - cy, &pipe_stub);
				y -= 41;
				break;
			case 8:
				y -= 20;
				e->DrawSprite(x - cx, y - cy, &pipe_straight_d);
				y -= 80;
			}
		}
	}

	olc::Sprite pipe_straight;          // 0 straight right                 
	olc::Sprite pipe_elbowZ;            // 1 z right     
	olc::Sprite pipe_elbow;             // 2 elbow down
	olc::Sprite pipe_straight_d;        // 3 straight down
	olc::Sprite pipe_elbowZd;           // 4 z down right
	olc::Sprite pipe_elbow_r;			// 5 elbow right
	olc::Sprite pipe_elbow_u;           // 6 elbow up
	olc::Sprite pipe_stub;              // 7 short vertical straight
										// 8 straight up

	int pipeLayoutIndex = -1;            
	int pipeConfig[6][20] = { // 6 different configurations
		18, 0, 0, 1, 2, 5,  0, 0, 4, 0, 1,  4, 0, 0, 0, 1,  0, 6, 7, 0,
		19, 0, 1, 0, 1, 0,  0, 2, 3, 5, 0,  0, 0, 0, 0, 0,  0, 6, 7, 7,
		18, 0, 0, 1, 0, 0,  0, 2, 5, 0, 0,  0, 1, 0, 4, 0,  0, 6, 7, 0,
		15, 0, 0, 0, 4, 0,  4, 0, 0, 0, 0,  0, 0, 0, 6, 7,  0, 0, 0, 0,
		14, 0, 0, 0, 0, 0,  0, 0, 0, 2, 5,  1, 0, 6, 8, 0,  0, 0, 0, 0,
		16, 4, 0, 1, 0, 4,  0, 1, 0, 4, 0,  1, 0, 4, 0, 1,  6, 0, 0, 0,

		 // level 7 needs different seed
	};
};