#pragma once

struct info_powerup
{
	info_powerup(int x, int y, int tp, int state) : posX(x), posY(y), type(tp), active(state) {}
	int posX;
	int posY;
	int type;
	int active;
};


class PowerUp : olc::GFX2D
{
public:
	PowerUp() {}

	void init(int level = 0)
	{
		info_powerup level_01[4] = { { 600, 200, 0, 1 }, { 900, 200, 1, 1 }, { 1200, 200, 2, 1 }, { 1400, 200, 3, 1 } };
		
		switch (level)
		{
		case 0:
		case 1:
		case 2:
			for (int i = 0; i < 4; i++) { powerUps.push_back(level_01[i]); }
			break;

			// todo : no more? :P

		}
		transform.Reset();
		transform.Scale(0.5f, 0.5f);
	}


	void update(float dt) 
	{
		for (auto &orb : powerUps)
		{
			switch (orb.type)
			{
			case 0:
				orb_red.update(dt);
				break;
			case 1:
				orb_green.update(dt);
				break;
			case 2:
				orb_blue.update(dt);
				break;
			case 3:
				orb_yellow.update(dt);
			}
		}
	}

	void draw(olc::PixelGameEngine* e, int cx, int cy) 
	{
		for (auto &orb : powerUps)
		{
			if (orb.active == 0) continue;
			
			Transform2D t = transform;
			t.Translate(orb.posX - cx, orb.posY - cy);

			switch (orb.type)
			{
			case 0:
				olc::GFX2D::DrawSprite(pManager->orbSprites[orb_red.id], t);
				break;
			case 1:
				olc::GFX2D::DrawSprite(pManager->orbSprites[orb_green.id], t);
				break;
			case 2:
				olc::GFX2D::DrawSprite(pManager->orbSprites[orb_blue.id], t);
				break;
			default:
				olc::GFX2D::DrawSprite(pManager->orbSprites[orb_yellow.id], t);
			}
		}
	}

public:
	Transform2D transform;
	std::vector<info_powerup> powerUps;

	// hack fest....any game orb originates here. 
	Core::sAnimInfo orb_red = { 0,  0,  5, 19.f, 0.f };
	Core::sAnimInfo orb_green = { 0,  6, 11, 15.f, 0.f };
	Core::sAnimInfo orb_blue = { 0, 12, 17, 10.f, 0.f };
	Core::sAnimInfo orb_yellow = { 0, 18, 23, 11.f, 0.f };

	Core::StateManager *pManager = nullptr;
};