// GDN_SideScroller (Worms Clone) 
// March 2019 Game Challenge

// other stuff tracking
// http://chrismdp.com/2015/06/how-to-quickly-add-bloom-to-your-engine/
// https://www.youtube.com/watch?v=f3Cr8Yx3GGA skinning animation

// https://www.youtube.com/watch?v=AAFkdrP1CHQ&index=1&list=PLmV5I2fxaiCI9IAdFmGChKbIbenqRMi6Z (John Blow) start (menu)
// https://www.youtube.com/watch?v=xfl0jHp1hAM enhanced animation (some other dude)

#include "olcPixelGameEngine.h" // the pixel engine

#include "GameState.h"
Core::States::Base_state* base_state;

class Game_GC201904 : public olc::PixelGameEngine
{
public:
	Game_GC201904()
	{
		sAppName = "GD.net Side Scroller : GoliathForge (2019)";
	}

private:
	Core::StateManager gameState;

public:

	bool OnUserCreate() override 
	{
		gameState.initialize(this, vec2((float)ScreenWidth(), (float)ScreenHeight()));
		return true; 
	}

	
	bool OnUserUpdate(float fElapsedTime) override 
	{
		if (gameState.isRunning())
		{
			gameState.update(fElapsedTime);
			gameState.draw();
		}
		else
		{
			gameState.shutdown();
			exit(0);
		}
		return true; 
	}


	bool OnUserDestroy() override 
	{ 
		gameState.shutdown();

		return true; 
	}

};


// ---------------------------------------------------------------------------------
// entry point ----------------------------------------------
int main()
{
#ifdef _DEBUG
	::ShowWindow(::GetConsoleWindow(), SW_SHOW);
	std::cout << "Pixel Game Engine initialization...";
#else
	::ShowWindow(::GetConsoleWindow(), SW_HIDE);
#endif

	Game_GC201904 demo;
	if (demo.Construct(800, 420, 1, 1))
	{
		if (demo.Start() == olc::FAIL)
			MessageBox(0, "Challange entry failed to start", "olc::pge", 0);
	}
	return 0;
}
