	#include <olcpixelgameengine.h>
#include "PhysicsObject.h"

// circle --------------------------------------------------------------------
std::vector<std::pair<float, float>> FactoryDefineStaticDummy()
{/*           X X X
           X         X
         X             X
         X             X
		 X             X
		   X         X
		      X X X
 */	std::vector<std::pair<float, float>> vecModel;
	//vecModel.push_back({ 0.f, 0.f });
	for (int i = 0; i < 10; i++)
	{
		vecModel.push_back({ cosf(i / 9.f * 2.f * 3.14159f)*dummyRadius, sinf(i / 9.f * 2.f * 3.14159f)*dummyRadius });
	}	return vecModel;
} std::vector<std::pair<float, float>> Dummy::vecModel = FactoryDefineStaticDummy();


// cross --------------------------------------------------------------------
std::vector<std::pair<float, float>> FactoryDefineStaticDebree()
{/*	      X
	      X  
	 X X     X X
	      X  
	      X
*/ 	std::vector<std::pair<float, float>> vecModel = { 
		{-1.f, 0.f}, {1.f, 0.f}, {0.f, -1.f}, {0.f, 1.f}, 
		{-2.f, 0.f}, {2.f, 0.f}, {0.f, -2.f}, {0.f, 2.f} 
	};  return vecModel;
} std::vector<std::pair<float, float>> Debre::vecModel = FactoryDefineStaticDebree();


// custum cup --------------------------------------------------------------------
std::vector<std::pair<float, float>> FactoryDefineStaticBallGoal()
{/*   X     insert goodness       X 
      X X        here           X X
        X X X               X X X 
            X X X X X X X X X
		          X X X
              X X X   X X X
                X X   X X
                  X   X
                  X   X
                    X
 */ std::vector<std::pair<float, float>> vecModel = {
		 {-7.f,-9.f},                                                                                      {7.f,-9.f},
		 {-7.f,-8.f}, {-6.f,-8.f},                                                             {6.f,-8.f}, {7.f,-8.f},
		 {-6.f,-7.f}, {-5.f,-7.f}, {-4.f,-7.f},                                    {4.f,-7.f}, {5.f,-7.f}, {6.f,-7.f},
		 {-4.f,-6.f}, {-3.f,-6.f}, {-2.f,-6.f},{-1.f,-6.f}, {0.f,-6.f}, {1.f,-6.f},{2.f,-6.f}, {3.f,-6.f}, {4.f,-6.f},
		                                 {-1.f,-5.f}, {0.f,-5.f}, {1.f,-5.f},
		             {-3.f,-4.f}, {-2.f,-4.f}, {-1.f,-4.f}, {1.f,-4.f}, {2.f,-4.f}, {3.f,-4.f},
		                         {-2.f, -3.f},{-1.f, -3.f},{1.f, -3.f},{2.f, -3.f},
				                              {-1.f, -2.f},{1.f, -2.f},
	                                          {-1.f, -1.f},{1.f, -1.f},
	                                                  {0.f, 0.f} 
	}; return vecModel;
} std::vector<std::pair<float, float>> BallGoal::vecModel = FactoryDefineStaticBallGoal();

// multi object? pooper and ramp --------------------------------------------------------------------
std::vector<std::pair<float, float>> FactoryDefineStaticPickFactory()
{/*         X X X
          X X X X X     lightning rod points
          X X   X X        (selectable)
          X X X X X
		    X X X
 */ std::vector<std::pair<float, float>> vecModel = {
		             {-1.f,-2.f}, {0.f,-2.f}, {1.f,-2.f},
		{-2.f,-1.f}, {-1.f,-1.f}, {0.f,-1.f}, {1.f,-1.f}, {2.f,-1.f},
		{-2.f,0.f}, {-1.f,0.f},                 {1.f,0.f}, {2.f,0.f},
		{-2.f,1.f}, {-1.f,1.f},   {0.f,1.f},    {1.f,1.f}, {2.f,1.f},
		              {-1.f,2.f}, {0.f,2.f}, {1.f,2.f}
	}; return vecModel;
} std::vector<std::pair<float, float>> BallBumper::vecModel = FactoryDefineStaticPickFactory();

// multi object? dummy that drags terrain and pickable ramp
std::vector<std::pair<float, float>> FactoryDefineStaticBallFactory()
{/*                  X X X
                   X       X
       X X X X X X X       X X X X X X X X
	     X X X X X X X X X X X X X X X X
				   X X X X X
					 X X X
					 X X X
					 X x X      // the delivery system
					 X X X      //  (non movable???)
					 X X X
				   X X X X X
	     X X X X X X X X X X X X X X X
	   X X X X X X X       X X X X X X X
       X     X                   X     X
	   X     X                   X     X
         X X                       X X
 */	std::vector<std::pair<float, float>> vecModel = {                           {-1.f,-7.f},{0.f,-7.f},{1.f,-7.f},
		                                                                        {-2.f,-6.f},           {2.f,-6.f},
		{-8.f,-5.f},{-7.f,-5.f},{-6.f,-5.f},{-5.f,-5.f},{-4.f,-5.f},{-3.f,-5.f},{-2.f,-5.f},           {2.f,-5.f},{3.f,-5.f},{4.f,-5.f},{5.f,-5.f},{6.f,-5.f},{7.f,-5.f},{8.f,-5.f},
		{-7.f,-4.f},{-6.f,-4.f},{-5.f,-4.f},{-4.f,-4.f},{-3.f,-4.f},{-2.f,-4.f},{-1.f,-4.f},{0.f,-4.f},{1.f,-4.f},{2.f,-4.f},{3.f,-4.f},{4.f,-4.f},{5.f,-4.f},{6.f,-4.f},{7.f,-4.f},
		                                                            {-2.f,-3.f},{-1.f,-3.f},{0.f,-3.f},{-1.f,-3.f},{-2.f,-3.f},
		                                                                        {-1.f,-2.f},{0.f,-2.f},{1.f,-2.f},
		                                                                        {-1.f,-1.f},{0.f,-1.f},{1.f,-1.f},
	                                                                            {-1.f, 0.f},{0.f, 0.f},{1.f, 0.f},
		                                                                        {-1.f, 1.f},{0.f, 1.f},{1.f, 1.f},
		                                                                        {-1.f, 2.f},{0.f, 2.f},{1.f, 2.f},
		                                                            {-2.f,3.f}, {-1.f,3.f}, {0.f,3.f}, {1.f,3.f}, {2.f,3.f},
  		  {-7.f,4.f},{-6.f,4.f}, {-5.f,4.f}, {-4.f,4.f}, {-3.f,4.f}, {-2.f,4.f},{-1.f,4.f}, {0.f,4.f}, {1.f,4.f},{2.f,4.f}, {3.f,4.f},{4.f,4.f}, {5.f,4.f},{6.f,4.f}, {7.f,4.f},
		       {-8.f,5.f}, {-7.f,5.f}, {-6.f,5.f}, {-5.f,5.f}, {-4.f,5.f}, {-3.f,5.f},{-2.f,5.f}, {2.f,5.f},{3.f,5.f}, {4.f,5.f},{5.f,5.f}, {6.f,5.f},{7.f,5.f}, {8.f,5.f},
		       {-8.f,6.f},                         {-5.f,6.f},                                                                   {5.f,6.f},                      {8.f,6.f},
		       {-8.f,7.f},                         {-5.f,7.f},                                                                   {5.f,7.f},                      {8.f,7.f},
		                   {-7.f,8.f}, {-6.f,8.f},                                                                                          {6.f,8.f}, {7.f,8.f}
	}; return vecModel;
} std::vector<std::pair<float, float>> BallFactory::vecModel = FactoryDefineStaticBallFactory();

