#include "levelTransition.h"
#include "../GameState.h"

void Core::States::LevelTranstion::draw() 
{
	Core::StateManager* manager = (StateManager*)pManager;
	olc::PixelGameEngine* e = manager->engine;

	char buf[32] = "";
	_itoa_s(level+2, buf, 10); // level is zero based. and doesn't increment until after finished

	e->SetPixelMode(olc::Pixel::ALPHA);

	if (bFillFade_thisFrame)
	{   // background fill
		e->FillRect(0, 0, 800, 420, olc::Pixel(0, 0, 0, 10));
		bFillFade_thisFrame = false;
	}

	int x = 315;
	int y = 175; // text
	olc::Pixel color = olc::Pixel(249, 255, 255, 2);
	e->DrawString(x, y, "Level", color, 3);
	e->DrawString(x + 140, y, buf, color, 3);

	e->SetPixelMode(olc::Pixel::NORMAL);

	if (finished)
	{
		manager->handleEvents(Core::eStateAction::play);
		finished = false;
		level++;
	}
}

void Core::States::LevelTranstion::update(float dt) 
{
	static float fillTrigger = 0.f;
	fillTrigger += dt;
	if (fillTrigger > 0.05f)
	{
		fillTrigger = 0.f;
		bFillFade_thisFrame = true;
	}

	runningTime += dt;
	if (runningTime > (duration + delay_in))
	{
		if (runningTime > (duration + delay_in + delay_out))
		{
			runningTime = 0.f;
			finished = true;
			return;
		}
		return;
	}
}


void Core::States::LevelTranstion::handleEvents() {}
void Core::States::LevelTranstion::resume() {}
void Core::States::LevelTranstion::pause() {}
void Core::States::LevelTranstion::shutdown() {}
void Core::States::LevelTranstion::initialize() {}