// file : levelTransition.h

#ifndef _engine_core_states_level_transition_h_
#define _engine_core_states_level_transition_h_

#include "base_state.h"

namespace Core {
	namespace States {

		class LevelTranstion : public Base_state 
		{
		public:
			LevelTranstion(void* _manager, vec2 _clientSize)
				: Base_state(_manager, "level_transition_state", _clientSize)
			{
				initialize();
			}
			void initialize();
			void shutdown();

			void pause();
			void resume();

			void handleEvents();
			void update(float _deltaTime);
			void draw();

		public:
			int level = 0;
			float bFillFade_thisFrame = false;

		private:
			float runningTime = 0.f; // current sequence time
			float duration = 2.f; // max (full on) time
			float delay_out = 2.f; // text fade out time
			float delay_in = 1.f;  // text fade in time
			bool finished = false;

		};

	}
}

#endif
