#include "loose.h"
#include "../GameState.h"

void Core::States::LevelLoose::draw()
{
	Core::StateManager* manager = (StateManager*)pManager;
	olc::PixelGameEngine* e = manager->engine;

	if (finished)
	{
		manager->handleEvents(Core::eStateAction::quit);
		finished = false;
	}
	e->SetPixelMode(olc::Pixel::ALPHA);

	if (bFillFade_thisFrame)
	{   // background fill
		e->FillRect(0, 0, 800, 420, olc::Pixel(205, 0, 0, 10));
		bFillFade_thisFrame = false;
	}

	int x = 300;
	int y = 175; // text
	olc::Pixel color = olc::Pixel(249, 255, 255, 2);
	e->DrawString(x, y, "_ FAIL _", color, 3);

	e->SetPixelMode(olc::Pixel::NORMAL);
}

void Core::States::LevelLoose::update(float dt)
{
	static float fillTrigger = 0.f;
	fillTrigger += dt;
	if (fillTrigger > 0.05f)
	{
		fillTrigger = 0.f;
		bFillFade_thisFrame = true;
	}

	runningTime += dt;
	if (runningTime > (duration + delay_in))
	{
		if (runningTime > (duration + delay_in + delay_out))
		{
			runningTime = 0.f;
			finished = true;
		}
	}
}


void Core::States::LevelLoose::handleEvents() {}
void Core::States::LevelLoose::resume() {}
void Core::States::LevelLoose::pause() {}
void Core::States::LevelLoose::shutdown() {}
void Core::States::LevelLoose::initialize() {}