// file : levelTransition.h

#ifndef _engine_core_states_loose_h_
#define _engine_core_states_loose_h_

#include "base_state.h"

namespace Core {
	namespace States {

		class LevelLoose : public Base_state
		{
		public:
			LevelLoose(void* _manager, vec2 _clientSize)
				: Base_state(_manager, "level_loose_state", _clientSize)
			{
				initialize();
			}
			void initialize();
			void shutdown();

			void reset() { runningTime = 0.f; finished = false; }
			void pause();
			void resume();

			void handleEvents();
			void update(float _deltaTime);
			void draw();

			bool bFillFade_thisFrame = false;

		private:

			float runningTime = 0.f; // current sequence time
			float duration = 4.f;    // max (full on) time
			float delay_out = 2.f;   // text fade out time
			float delay_in = 1.f;    // text fade in time
			bool finished = false;

		};

	}
}

#endif
