// file : menu.cpp
//
// brief : 
// The main menu look and feel
// It all happens right here yo.
// When we're done, the manager takes over and we freeze while whatever process stepped up
// 
//        
//

#include "menu.h"
#include "../GameState.h"
bool areYouSure = false;

#include <hex.h> // common foo

#include "../SFX/Lightning.h"
LightningBolt lightning(vec2(550,100), vec2(750,100), olc::WHITE);

struct sButton
{
	RECT rect;   // [left, top, right, bottom]                                
	RECT offset; // [text shift x, text shift y, reserved_01, reserved_02]          mwk: reserved = state or button down/lock flags
};

void Core::States::Menu::initialize()
{
	rectPlay       = { 360, 140, 440, 160 }; // 80 x 20
	rectQuit       = { 360, 165, 440, 185 }; // need more data or buttons are a known size
	rectVolume     = { 360, 190, 440, 210 }; // 80 x 20
	rectDifficulty = { 360, 215, 440, 235 };
	rectYes        = { 360,  35, 398,  55 };
	rectNo         = { 402,  35, 440,  55 };
	rectGraph01    = { 690, 300, 710, 380 };
	rectGraph02    = { 760, 300, 780, 380 };

	Core::StateManager* manager = (Core::StateManager*)pManager;
	int x1 = rectGraph01.left + 10;
	int y1 = rectGraph01.bottom - (manager->dSlider01 * (rectGraph01.bottom - rectGraph01.top));
	int x2 = rectGraph02.left + 10;
	int y2 = rectGraph02.bottom - (manager->dSlider02 * (rectGraph02.bottom - rectGraph02.top));
	lightning.CreateBolt(vec2(x1, y1), vec2(x2, y2), &lightning.segments1);
	lightning.CreateBolt(vec2(x1, y1), vec2(x2, y2), &lightning.segments2);
}

void Core::States::Menu::shutdown()     {}
void Core::States::Menu::pause()        {}
void Core::States::Menu::resume()       {}
void Core::States::Menu::handleEvents() {}


void Core::States::Menu::update(float _deltaTime)
{
	Core::StateManager* manager = (StateManager*)pManager;
	int x1 = rectGraph01.left + 10;
	int y1 = rectGraph01.bottom - (manager->dSlider01 * (rectGraph01.bottom - rectGraph01.top));
	int x2 = rectGraph02.left + 10;
	int y2 = rectGraph02.bottom - (manager->dSlider02 * (rectGraph02.bottom - rectGraph02.top));

	//whoops...
	lightning.Update(_deltaTime, vec2(x1, y1), vec2(x2, y2));

	orb_red.update(_deltaTime);
	orb_green.update(_deltaTime);
	orb_blue.update(_deltaTime);
	orb_yellow.update(_deltaTime);

	timer_03_tps += _deltaTime;

	// red ball ---------------------------------
	vec2 ptA = { rectGraph01.left + ((rectGraph01.right - rectGraph01.left) * 0.5f),
				 rectGraph01.bottom - ((rectGraph01.bottom - rectGraph01.top) * float(manager->dSlider01)) };
	vec2 ptB = { rectGraph02.left + ((rectGraph02.right - rectGraph02.left) * 0.5f),
				 rectGraph02.bottom - ((rectGraph02.bottom - rectGraph02.top) * float(manager->dSlider02)) };
	float cElevation = 0;
	if (ptA.y < ptB.y)
		cElevation = ptA.y + ((ptB.y - ptA.y)*0.5f);
	else
		cElevation = ptA.y - ((ptA.y - ptB.y)*0.5f);

	if (ptRedBall.y > cElevation - 5.f)
	{
		ptRedBall.y = cElevation - 5.f;
		velRedBall.y = -110.f;
	}
	
	//vec2 vC = (ptB - ptA).norm();       // left to right
	velRedBall.y += 98.1f * _deltaTime; // calculate the advance
	//vec2 vP = (ptRedBall - ptA).norm();          
	//if ((vP.x < vC.x) && (vP.y > vC.y))
	//	velRedBall.y = -80.f;*/

	ptRedBall += velRedBall * _deltaTime;
}

foo::Hex hexPattern;
foo::graph graphGizmo;

void Core::States::Menu::draw()
{
	// ------------------- Game Menu -------------------------

	Core::StateManager* manager = (StateManager*)pManager;
	olc::PixelGameEngine* e = manager->engine;

	olc::Pixel colorDefault = olc::Pixel(255, 255, 255);
	olc::Pixel colorHover = olc::Pixel(255, 255, 0);
	e->Clear(olc::BLACK);

	// page title text ----------------------------------
	vec2 textOffset = { 25.f, 6.f };
	int x = int(rectPlay.left - 30); // x, y reused ---v
	int y = int(rectPlay.top - 60);
	e->DrawString(x, y, "Main Menu", olc::WHITE, 2);

	//                                                                                           _
	//  .---  todo : don't like handling user input inside a draw routine...fix me  ----.    \_(O,O)_
	//  V                                                                               V        ~   \
	
	POINT cursorPos;
	cursorPos.x = manager->engine->GetMouseX();
	cursorPos.y = manager->engine->GetMouseY();

	// little art background things  -------------------
	hexPattern.draw(vec2(0, 0), e);

	graphGizmo.A = manager->dSlider01 * 15.0;
	graphGizmo.f = manager->dSlider02 * 0.25;
	graphGizmo.draw(vec2(475, 365), 0.f, 5.f, 160, e);


	// buttons -------------------------------------------------------------------
	auto onButton = [cursorPos, textOffset, &x, &y, e, manager](RECT rect, std::string label, Core::eStateAction action) 
	{
		bool clicked = false;
		e->DrawRect(rect.left, rect.top, rect.right - rect.left, rect.bottom - rect.top);
		x = int(rect.left + ((rect.right - rect.left)*0.5) - (4*label.length()) + 1);
		y = int(rect.top + (rect.bottom - rect.top) * 0.25f + 1);
		
		olc::Pixel textColor = olc::WHITE;
		if (::PtInRect(&rect, cursorPos))
		{	textColor = olc::YELLOW;
			if (e->GetMouse(0).bPressed)
			{	
				if (action != none)
				{
					e->Clear(olc::BLACK);
					manager->handleEvents(action);
				}
					
				manager->playSound(0, Core::eSoundTypes::tick, 0.0, 0.005);
				clicked = true;
			}
		}
		if(!clicked)
			e->DrawString(x, y, label, textColor);
		return clicked;
	};
	
	if(onButton(rectQuit, "Quit", Core::eStateAction::none)) areYouSure = true;



	// GUI - sliders ----------------------------------------------------------------------	
	bool onHoverVolume     = ::PtInRect(&rectVolume, cursorPos);
	bool onHoverDifficulty = ::PtInRect(&rectDifficulty, cursorPos);
	bool onHoverGraph01    = ::PtInRect(&rectGraph01, cursorPos);
	bool onHoverGraph02    = ::PtInRect(&rectGraph02, cursorPos);

	auto isWithin = [](float px, float py, float cx, float cy) 
	{ 
		float dx = px - cx;
		float dy = py - cy;
		float d2 = (dx*dx) + (dy*dy);
		if(d2 < 400.f) // 20px radius^2
			return true;
		else
			return false;
	};

	auto onSlider = [&cursorPos, &x, &y, e, isWithin](RECT rect, bool onHover, double &value, std::string label = "" )
	{
		int mx = rect.right - rect.left; // width
		int my = rect.bottom - rect.top; // height
		if (mx < my)
		{  	
			x = rect.left + ((rect.right - rect.left) / 2.0f); // center 
			y = rect.bottom;                                   // bottom
			e->DrawLine(x, y, x, rect.top, olc::WHITE);        // vertical
			if (value <= 1.0)
				y = rect.bottom - (my * value);
			else
				y = rect.top;
		}
		else
		{   
			x = rect.left;
			y = rect.top + ((rect.bottom - rect.top) / 2.0f);
			e->DrawLine(x, y, x + 10, y, olc::WHITE);
			e->DrawString(x + 17, y - 3, label);
			e->DrawLine(rect.right-10, y, rect.right, y, olc::WHITE); // slider line horz
			
			// locate thumb
			if (value <= 1.0)
				x = rect.left + (mx * value);
			else
				x = rect.right; // max one

			e->DrawString(rect.left - 24, rect.top + 6, "(-)");
			e->DrawString(rect.right + 4, rect.top + 6, "(+)");
		}
		// draw thumb
		e->DrawCircle(x, y, 5.0, olc::BLACK);
		if (isWithin(x, y, float(cursorPos.x), float(cursorPos.y)) && (e->GetMouse(0).bHeld))
		{   // cursor<-->thumb(radius)
			int t;
			if (mx < my)
			{	t = rect.bottom - cursorPos.y;
				if (t >= 0)
				{	value = float(t) / float(my);
					y = cursorPos.y;// rect.bottom - (my * value);
				}
			}
			else
			{	t = cursorPos.x - rect.left;
				if (t >= 0) // min zero
				{	value = float(t) / float(mx); // zero to one set for next run
					x = cursorPos.x;// rect.left + (mx * value);
				}
			}
		}
		e->DrawCircle(x, y, 5.0, onHover ? olc::YELLOW : olc::Pixel(100, 100, 255, 255));
	};

	onSlider(rectVolume, onHoverVolume, manager->dVolume, "Volume");

	std::string strDifficultySetting = " Easy";
	if (manager->difficulty > 0.3f) strDifficultySetting = "Normal";
	if (manager->difficulty > 0.7f) strDifficultySetting = "Extreme";
	onSlider(rectDifficulty, onHoverDifficulty, manager->difficulty, strDifficultySetting);

	onSlider(rectGraph01, onHoverGraph01, manager->dSlider01);
	onSlider(rectGraph02, onHoverGraph02, manager->dSlider02);



	// ----------------------------------------------------------------------------------------
	// message box
	if (areYouSure) // maybe a priority rect (something movable ....uh oh.... balance)
	{   
		if(onButton(rectYes, "Yes", Core::eStateAction::none)) manager->quit();
		if(onButton(rectNo, "No", Core::eStateAction::none)) areYouSure = false;
		manager->engine->DrawString(rectYes.left - 10, rectYes.bottom+10, "Are you sure?", olc::WHITE);
	}



	lightning.Draw(e);

	
	// draw some power ups in the upper right corner
	vec2 vt = { 505.f, 150.f };
	auto onPowerUpPressed = [&vt, e, cursorPos](Core::sAnimInfo &orb) 
	{
		if (e->GetMouse(0).bPressed)
		{
			RECT rt = { int(vt.x), int(vt.y), int(vt.x+32), int(vt.y+32) };
			if (::PtInRect(&rt, cursorPos))
			{
				orb.speed *= -1.f;
			}
		}
	};
	
	olc::GFX2D::Transform2D t;
	t.Reset();
	t.Translate(vt.x, vt.y);

	e->SetPixelMode(olc::Pixel::ALPHA);
	olc::GFX2D::DrawSprite(manager->orbSprites[orb_red.id], t, false);
	onPowerUpPressed(orb_red);

	t.Translate(50.f, 40.f); vt += vec2(50, 40);
	olc::GFX2D::DrawSprite(manager->orbSprites[orb_green.id], t, false);
	onPowerUpPressed(orb_green);

	t.Translate(0.f, -40.f); vt += vec2(0, -40);
	olc::GFX2D::DrawSprite(manager->orbSprites[orb_yellow.id], t, false);
	onPowerUpPressed(orb_yellow);

	t.Translate(50.f, 0.f); vt += vec2(50, 0);
	olc::GFX2D::DrawSprite(manager->orbSprites[orb_blue.id], t, false);
	onPowerUpPressed(orb_blue);

	e->SetPixelMode(olc::Pixel::NORMAL);






	// user control map
	vec2 pm = {320.f, 260.f};
	//e->DrawString(pm.x, pm.y, "Controls :"); pm.y += 22;
	e->DrawString(pm.x, pm.y, "Left"); pm.x += 60;
	auto onDrawKey = [&pm, &e](std::string key)
	{
		e->DrawLine(pm.x, pm.y, pm.x + 14, pm.y);
		e->DrawLine(pm.x + 14, pm.y, pm.x + 14, pm.y + 14);
		e->DrawLine(pm.x + 14, pm.y + 14, pm.x, pm.y + 14);
		e->DrawLine(pm.x, pm.y + 14, pm.x, pm.y);
		e->DrawString(pm.x + 4, pm.y + 4, key);
	};
	pm.y -= 20;
	onDrawKey("W"); pm.x += 25;  
	e->DrawString(pm.x, pm.y, "Jump"); pm.x -= 45; pm.y += 20;
	onDrawKey("A"); pm.x += 20;//pm.x += 14; pm.y -= 20;
	//onDrawKey("W"); pm.x += 6; pm.y += 20;
	onDrawKey("S"); pm.x += 20;
	onDrawKey("D"); pm.x += 22;
	e->DrawString(pm.x, pm.y, "Right");	pm.x -= 52; pm.y += 22;
	e->DrawString(pm.x, pm.y, "Block");

	pm.x = 500; pm.y = 272;
	e->DrawString(pm.x, pm.y, "Left"); pm.x += 40;
	pm.x += 20; pm.y -= 20;
	onDrawKey("^"); pm.x += 25; 
	e->DrawString(pm.x, pm.y, "Jump");
	pm.x -= 45; pm.y += 20;
	onDrawKey("<"); pm.x += 20;
	onDrawKey("V"); pm.x += 20;
	onDrawKey(">"); pm.x += 22;
	e->DrawString(pm.x, pm.y, "Right");	pm.x -= 52; pm.y += 22;
	e->DrawString(pm.x, pm.y, "Block");

	e->DrawString(500, 130, "--- Mystery orbs ---");
	e->DrawString(600, 202, "<-- Slow time");

	e->DrawString(300, 315, "Mouse pick / drag blinking blue circles");
	e->DrawString(300, 330, "Direct the red balls to the hidden goal");
	e->DrawString(300, 345, "Protect your pipes from the yellow pixie pin");
	e->DrawString(300, 380, "Move the character to advance the camera");
	e->DrawString(300, 395, "Red balls that bounce on the terrain > three times go boom!");

	// sample blue thumb ----------------------------
	static bool isThumbOn = false;
	if (isWithin(ptBlueThumb.x, ptBlueThumb.y, cursorPos.x, cursorPos.y) && e->GetMouse(0).bHeld)
	{
		ptBlueThumb.x = cursorPos.x;
		ptBlueThumb.y = cursorPos.y;
	}
	if (timer_03_tps > 0.5f) { timer_03_tps = 0.f; if (isThumbOn) isThumbOn = false; else isThumbOn = true; }
	e->DrawCircle(ptBlueThumb.x, ptBlueThumb.y, 10, olc::BLUE);
	e->DrawCircle(ptBlueThumb.x, ptBlueThumb.y, 9, isThumbOn ? olc::YELLOW : olc::WHITE);
	e->DrawCircle(ptBlueThumb.x, ptBlueThumb.y, 7, olc::BLUE);

	// bouncing ball
	e->DrawCircle(ptRedBall.x, ptRedBall.y, 6, olc::RED);



	//// cursor debug output
	//std::string cursorInfo = "CursorPos ";
	//char buf[16] = "";
	//_itoa_s(int(cursorPos.x), buf, 10);
	//e->DrawString(20, 20, std::string(buf));
	//_itoa_s(int(cursorPos.y), buf, 10);
	//e->DrawString(70, 20, std::string(buf));

	if (onButton(rectPlay, "Play", Core::eStateAction::play)) { ; }
}

