// file : menuState.h

#ifndef _engine_core_states_menu_h_
#define _engine_core_states_menu_h_

#include "base_state.h"

namespace Core {
	namespace States {

		class Menu : public Base_state
		{
		public:
			Menu(void* _manager, vec2 _clientSize) : Base_state(_manager, "menu_state", _clientSize) { initialize(); }
			void initialize();
			void shutdown();

			void pause();
			void resume();

			void handleEvents();
			void update(float _deltaTime);
			void draw();

			std::string text_playButton = "Play";
		private:
			RECT rectPlay;
			RECT rectQuit;
			RECT rectVolume;
			RECT rectDifficulty;
			RECT rectYes;
			RECT rectNo;
			RECT rectGraph01;
			RECT rectGraph02;

			sAnimInfo orb_red =    { 0,  0,  5, 19.f, 0.f };
			sAnimInfo orb_green =  { 0,  6, 11, 15.f, 0.f };
			sAnimInfo orb_blue =   { 0, 12, 17, 10.f, 0.f };
			sAnimInfo orb_yellow = { 0, 18, 23, 11.f, 0.f };

			float timer_03_tps = 0.f;
			vec2 ptBlueThumb = { 650, 300 };
			vec2 ptRedBall = { 735, 35 };
			vec2 velRedBall = { 0.f, 1.5f };
		};
	}
}

#endif
