#ifndef TERRAIN_MAP_H
#define TERRAIN_MAP_H

class Terrain
{
public:

	enum eType
	{
		air,
		land,
		water,
		pipe,
		goal
	};

	Terrain() {                                 }
	~Terrain() { if (map != nullptr) delete map; }

	int nMapWidth = 1600;
	int nMapHeight = 450;
	unsigned char *map = nullptr;
	bool isStable = true; // set false when map modified and stray pixels are still falling

	void Reset();
	bool CreateMap();

	void Update(float fElapsedTime);

	void Carve(vec2 pos, float radius, float strength);
	void Buldge(vec2 pos, float radius, float strength);

};

void PerlinNoise1D(int nCount, float *fSeed, int nOctaves, float fBias, float *fOutput);


#endif